<?php
namespace Df\Payment\W\Exception;
/**
 * 2017-01-08
 * Мягкая исключительная ситуация:
 * сообщает платёжной системе, что соообщение не предназначалось нашему магазину.
 * Такое возможно, например, когда мы выполнили из административной части Stripe
 * запрос на capture для локального (localhost) магазина, а оповещение пришло на mage2.pro/sandbox.
 * Так вот, если просто свалиться с исключительной ситуацией (код HTTP 500),
 * то Stripe задолбает повторными запросами.
 * Надо вернуть код HTTP 200 и человекопонятное сообщение: мол, запрос — не для нашего магазина.
 * @used-by \Df\Payment\W\Nav::p()
 * 2017-03-30
 * Надо наследоваться именно от \Df\Core\Exception, а не от @see \Exception,
 * потому что мы используем конструкцию df_error(new NotForUs('...')):
 * @see \Df\Payment\W\Nav::p()
 */
final class NotForUs extends \Df\Core\Exception {}