/**
 * 2017-02-05
 * @see Dfe_CheckoutCom/main: https://github.com/mage2pro/checkout.com/blob/1.3.21/view/frontend/web/main.js
 * @see Dfe_Moip/card: https://github.com/mage2pro/moip/blob/0.9.0/view/frontend/web/card.js
 * @see Dfe_Omise/main: https://github.com/mage2pro/omise/tree/1.9.0/view/frontend/web/main.js
 * @see Dfe_Paymill/main: https://github.com/mage2pro/paymill/tree/1.5.0/view/frontend/web/main.js
 * @see Dfe_Spryng/main: https://github.com/mage2pro/spryng/tree/1.1.10/view/frontend/web/main.js
 * @see Dfe_Square/main: https://github.com/mage2pro/square/tree/1.2.1/view/frontend/web/main.js
 * @see Dfe_Stripe/main: https://github.com/mage2pro/stripe/tree/1.10.0/view/frontend/web/main.js
 * @see Dfe_TBCBank/main: https://github.com/mage2pro/tbc-bank
 * @see Dfe_TwoCheckout/main: https://github.com/mage2pro/2checkout/blob/1.4.12/view/frontend/web/main.js
*/
define(['df-lodash', 'Df_Payment/card', 'jquery'], function(_, parent, $) {'use strict';
/** 2017-09-06 @uses Class::extend() https://github.com/magento/magento2/blob/2.2.0-rc2.3/app/code/Magento/Ui/view/base/web/js/lib/core/class.js#L106-L140 */	
return parent.extend({
	/**
	 * 2017-10-12
	 * These data are submitted to the M2 server part
	 * as the `additional_data` property value on the «Place Order» button click:
	 * @used-by Df_Payment/mixin::getData():
	 *		getData: function() {return {additional_data: this.dfData(), method: this.item.method};},
	 * https://github.com/mage2pro/core/blob/2.8.4/Payment/view/frontend/web/mixin.js#L224
	 * @override
	 * @see Df_Payment/card::dfData()
	 * @see Dfe_Moip/main::dfData()
	 * https://github.com/mage2pro/moip/blob/0.5.7/view/frontend/web/main.js#L9-L19
	 * @see Dfe_Square/main::dfData()
	 * https://github.com/mage2pro/square/blob/2.0.0/view/frontend/web/main.js#L44-L57
	 * @see Dfe_Vantiv/main::dfData()
	 * @returns {Object}
	 */
	dfData: function() {return _.assign(this._super(),
		!this.tokenResp ? {} : this.dfDataFromTokenResp(this.tokenResp)
	);},
	/**
	 * 2017-10-12
	 * @used-by dfData()
	 * @see Dfe_Stripe/main::dfDataFromTokenResp()
	 * @param {Object} r
	 * @returns {Object}
	 */
	dfDataFromTokenResp: function(r) {return {};},
   /** 2017-02-07 @returns {String} */
	publicKey: function() {return this.config('publicKey');},
    /**
	 * 2017-02-16
	 * @abstract
	 * @used-by placeOrder()
	 * @param {*} status
	 * @returns {Boolean}
	 */
	tokenCheckStatus: function(status) {return null;},
    /**
	 * 2017-02-16
	 * @abstract
	 * @used-by placeOrder()
	 * https://github.com/mage2pro/core/blob/2.7.9/StripeClone/view/frontend/web/main.js?ts=4#L73
	 * @param {Object} params
	 * @param {Function} callback
	 */
	tokenCreate: function(params, callback) {},
    /**
	 * 2017-02-16
	 * @abstract
	 * @used-by placeOrder()
	 * @param {Object|Number} status
	 * @param {Object} resp
	 * @returns {String}
	 */
	tokenErrorMessage: function(status, resp) {return null;},
    /**
	 * 2017-02-16
	 * @abstract
	 * @used-by placeOrder()
	 * @param {Object} resp
	 * @returns {String}
	 */
	tokenFromResponse: function(resp) {return null;},
    /**
	 * 2017-02-16
	 * @abstract
	 * @used-by placeOrder()
	 * https://github.com/mage2pro/core/blob/2.7.9/StripeClone/view/frontend/web/main.js?ts=4#L73
	 * @returns {Object}
	 */
	tokenParams: function() {return null;},
	/**
	 * 2017-02-16
	 * @override
	 * @see Magento_Checkout/js/view/payment/default::placeOrder()
	 * https://github.com/magento/magento2/blob/2.2.0-RC1.5/app/code/Magento/Checkout/view/frontend/web/js/view/payment/default.js#L126-L158
	 *		placeOrder: function(data, event) {
	 *			var self = this;
	 *			if (event) {
	 *				event.preventDefault();
	 *			}
	 *			if (this.validate() && additionalValidators.validate()) {
	 *				this.isPlaceOrderActionAllowed(false);
	 *				this.getPlaceOrderDeferredObject()
	 *				.fail(function() {self.isPlaceOrderActionAllowed(true);})
	 *				.done(function() {
	 *					self.afterPlaceOrder();
	 *					if (self.redirectAfterPlaceOrder) {
	 *						redirectOnSuccessAction.execute();
	 *					}
	 *				});
	 *				return true;
	 *			}
	 *			return false;
	 *		},
	 * @used-by Df_Payment/main.html:
	 *		<button
	 *			class="action primary checkout"
	 *			type="submit"
	 *			data-bind="
	 *				click: placeOrder
	 *				,css: {disabled: !isPlaceOrderActionAllowed()}
	 *				,enable: dfIsChosen()
	 *			"
	 *			disabled
	 *		>
	 *			<span data-bind="df_i18n: 'Place Order'"></span>
	 *		</button>
	 * https://github.com/mage2pro/core/blob/2.9.10/Payment/view/frontend/web/template/main.html#L57-L68
	 * https://github.com/magento/magento2/blob/2.1.0/lib/web/knockoutjs/knockout.js#L3863
	 * @param {this} _this
	 * @param {Event} event
	 */
	placeOrder: function(_this, event) {
		if (event) {
			event.preventDefault();
		}
		/**
		 * 2017-07-27
		 * It looks like the standard jQuery form validation does not work for us
		 * because of the jQuery Validate plugin code:
		 *		.filter(function () {
		 *			if (!this.name && validator.settings.debug && window.console) {
		 *				console.error("%o has no name assigned", this);
		 *			}
		 *			// select only the first element for each name, and only those with rules specified
		 *			if (this.name in rulesCache || !validator.objectLength($(this).rules())) {
		 *				return false;
		 *			}
		 *			rulesCache[this.name] = true;
		 *			return true;
		 *		});
		 * https://github.com/magento/magento2/blob/2.2.0-RC1.5/lib/web/jquery/jquery.validate.js#L487-L499
		 * Stripe and its clones forbids us to assign the `name` attribute to the bank card form elements,
		 * and the jQuery Validate plugin acccounts the elements by their names,
		 * so it does not work for our bank card forms.
		 * 2017-07-28
		 * I have patched the jQuery Validate plugin here:
		 * https://github.com/mage2pro/core/blob/2.9.12/Core/view/base/web/main.js#L23-L72
		 */
		if (this.validate()) {
			// 2017-07-26 «Sometimes getting duplicate orders in checkout»: https://mage2.pro/t/4217
			this.state_waitingForServerResponse(true);
			if (!this.isNewCardChosen()) {
				/**
				 * 2016-08-23
				 * Комментарий для Stripe:
				 * Идентификаторы карт начинаются с приставки «card_»
				 * (например: «card_18lGFRFzKb8aMux1Bmcjsa5L»),
				 * а идентификаторы токенов — с приставки «tok_»
				 * (например: «tok_18lWSWFzKb8aMux1viSqpL5X»),
				 * тем самым по приставке мы можем отличить карты от токенов,
				 * и поэтому для карт и токенов мы можем использовать одну и ту же переменную.
				 */
				this.token = this.currentCard();
				this.placeOrderInternal();
			}
			else {
				this.tokenCreate(this.tokenParams(), $.proxy(function(status, resp) {
					if (!this.tokenCheckStatus(status)) {
						this.showErrorMessage(this.tokenErrorMessage(status, resp));
						this.state_waitingForServerResponse(false);
					}
					else {
						this.token = this.tokenFromResponse(resp);
						this.tokenResp = resp;
						this.placeOrderInternal();
					}
				}, this));
			}
		}
	},	
});});